SystemOrganization addCategory: #'GBT-DSL_BuddyWallet'!

Object subclass: #BuddyWallet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_BuddyWallet'!

!BuddyWallet class methodsFor: 'example' stamp: 'hk 3/21/2017 14:26'!
buddyWallet  
	^self new buddyWallet! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/14/2016 10:37'!
buddyWallet: userName  
	^self new buddyWallet: userName ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 3/14/2017 13:08'!
exampleClear
	GbtBizAppServer clearStore. 
	GbtSVO initialize. ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 1/4/2017 14:10'!
exampleData
	self new storeAccounts ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 3/21/2017 14:26'!
exampleRun
	self new buddyWallet open
! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/17/2016 16:20'!
exampleRunLogin
	self new login open
! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
account
	^GbtThing struct: 'Account' define: {
		{ #summary . '#firstName #nick' }.
		{ #nick . #val: . #soleAccount }.
		{ #IBAN . #val: . '' }.
		{ #amount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
		{ #dispo . #no: . 0 }.
		{ #transferLimit . #no: . 1000 }.
		{ #person . #thing: . self contact}.
	}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 1/23/2017 12:19'!
account01
	"self new account01 edit"
	^self account
		bizId: self nextBizID;
		nick: #firstAccount;
		IBAN: 'DE51 1234 5678 9876 5432' ;	
		amount: 1000;
		firstName: #Lisa ;
		lastName: #Schmitz;
		yourself.

! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 1/23/2017 12:19'!
account02
	"self new account02 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9876 1234' ;	
		amount: 500;
		firstName: #Tom ;
		lastName: #Taylor;
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 1/23/2017 12:19'!
account03
	"self new account03 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0054 1234' ;	
		amount: 1000;
		firstName: #Helmut ;
		lastName: #Lange;
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 1/23/2017 12:19'!
account04
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0045 9876';
		nick: #otherAccount;
		amount: -500;
		firstName: #Lisa;
		lastName: #Schmitz;
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 1/23/2017 12:19'!
account05
	"self new account05 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9999 7777' ;	
		amount: 800;
		firstName: #Helmut ;
		lastName: #Schmidt;
		yourself! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
address
	^GbtThing struct: 'Address' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:22'!
buddies 
	^GbtBigListAC struct: 'Buddies' define: {
		{#displayAs: . 'Buddies'} .
		{#uiSpec:icon: . #GbtListUI . #crm} .
		{#templates: . self account} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName lastName #(nick account))} .
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:22'!
buddyContext  
	^GbtPlainAC struct: 'BuddyContext' define: {
		{#displayAs: . 'Buddy'  } .
		{#uiSpec:icon: . #GbtItemUI . #crm}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:22'!
buddyWallet  
	"self new buddyWallet open" 

	^GbtPlainAC struct: 'BuddyWallet' define: {
		{#aspect:on: . self myAccounts . #customer  } .
		{#aspect:on: . self buddies . #crm  } .
		{#aspect:on: . self transfers . #wallet  } .
		{#uiSpec:icon: . #GbtMainUI . #walletBig} .
		{#extent: . (800 @ 600)}.
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
contact
	^GbtThing struct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 1/4/2017 18:14'!
doitBehavior: behName  
	^GbtBehavior newStruct: behName arguments: #() define: #(
		READSLOT #(source vSourceNick)							"assign the accounts to the roles"
		READSLOT #(target vTargetName)							"get the source nickname and the target name"
		ASKROLE #(MyAccounts vSourceNick transferSource) 	"get  accounts for source"
		ASKROLE #(Buddies vTargetName transferSink) 		"and target into the roles"
		TRANSFORM #(transferSource SourceDecl sourceVar)	"get a.o. the source amount"
		TRANSFORM #(transferSink SinkDecl sinkVar)			"and the sink amount"
		COMPOSE #(TransferDecl sourceVar	sinkVar)			"make the core tx thing with the pool thing,too"						
		CHECK #transferCheck 										"check contraints"
		READSLOT #(newSourceAmount newSourceA) 				"read the final"
		READSLOT #(newSinkAmount newSinkA) 					"account values"
		WRITESLOT #(newSourceA transferSource amount) 		"write them"
		WRITESLOT #(newSinkA transferSink amount) 			"into the accounts"
		SAVECONTEXT #(transferSource Buddies)				"shall be saved in MyAccounts AND Buddies"
		SAVECONTEXT #(transferSink MyAccounts)				"shall be saved in MyAccounts AND Buddies"
		COMMIT #void 												"commit the tx"
		ASSIGNTODAY #(contextVO date)
	)! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 14:53'!
installDeclaratives
	self sinkDecl; sourceDecl; transferDecl! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 3/14/2017 10:36'!
installUsers
	#(Tom Lisa) do: [:u| GbtBizAppServer default addUser: u withRole: 
			(GbtRole forExecute 
				addFilter: '#firstName = ''',u asString, '''' for: #MyAccounts;
				addFilter: '#senderName = ''',u asString, '''' for: #Transfers) ].
	#(Tony Robert) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forWrite )].
	#(Bob) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forRead )]
! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 16:11'!
login
	self installUsers.
	^ GbtLoginAC
		struct: 'BuddyWalletLogin'
		define:
			{{#uiSpec:icon: . nil . #walletBig}.
			{#displayAs: . #BuddyWallet}.
			{#appClass:selector: . #BuddyWallet . #buddyWallet}.
			{#legalText: . 'GloConn International © 2016'}}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:23'!
myAccountContext  
	^GbtPlainAC struct: 'MyAccountContext' define: {
		{#displayAs: . 'MyAccount'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:23'!
myAccounts  
	^GbtBigListAC struct: 'MyAccounts' define: {
		{#displayAs: . 'MyAccounts'} .
		{#noPolicyPrefix: . 'Acc'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self account} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(nick nickName)  amount IBAN)} .
		{#subcontext: . self myAccountContext}}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 3/20/2017 18:05'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #MyAccounts! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 3/14/2017 13:01'!
sinkDecl
	^GbtDeclarative struct: 'SinkDecl' define: {
		{ #oldSinkAmount . #tag: .#amount } }! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 3/14/2017 13:01'!
sourceDecl
	^GbtDeclarative struct: 'SourceDecl' define: {
		{ #oldSourceAmount . #tag: . #amount }.
		{ #dispo } .
		{ #transferLimit} .
	}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 3/21/2017 17:02'!
storeAccounts
	"creates the noPolicy for the test data"
	GbtBizAppServer default contextNoPolicyOf: #MyAccounts prefix: #Acc	.
	self account01 store.
	self account02 store.
	self account03 store. 
	self account04 store.
	self account05 store! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 3/14/2017 13:01'!
transfer
	"at the core of the calculation"
	^GbtThing struct: 'Transfer' define: {
		{ #newSourceAmount . #calc: . '#oldSourceAmount - #transferAmount' }.
		{ #newSinkAmount . #calc: . '#oldSinkAmount + #transferAmount' } .
		{ #limitConstraint . #constraint:ifViolated: . '#transferAmount asNumber < #transferLimit asNumber' . 'limit exceeded'} .
		{ #dispoConstraint . #constraint:ifViolated: . '#oldSourceAmount asNumber - #transferAmount asNumber + #dispo asNumber >= 0' . 'no balace cover'} .
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:23'!
transferContext 
	self installDeclaratives .
	^GbtPlainAC struct: 'TransferContext' define: {
		{#displayAs: . 'TransferOrder'  } .
		{#uiSpec:icon: . #GbtItemUI . #wallet}.
		{#txThings: . #(transferSource transferSink) }.
		{#chooseFor:use:from: . #source . #nick . self myAccounts}.
		{#chooseFor:use:from: . #target . #firstName . self buddies }.
		{#poolThings: . self transfer}.
		{#menu: . #doit}.
		{#behavior: . self doitBehavior: #doit}.
		{#createBehaviors: . #(userName) }.
		{#behavior:actions: . #userName . #(ASSIGNUSER senderName)}.
	}! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 3/14/2017 13:01'!
transferDecl
	"takes as source i) the transformed source, ii) the transfer order and iii) the transfer thing "
	^GbtDeclarative struct: 'TransferDecl' define: {
		{ #oldSourceAmount }.
		{ #oldSinkAmount }.
		{ #dispo } .
		{ #transferLimit} .
		{ #transferAmount} .
		{ #newSourceAmount }.
		{ #newSinkAmount } .
		{ #limitConstraint } .
		{ #dispoConstraint } .
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
transferOrder
	^GbtThing struct: 'TransferOrder' define: {
		{ #summary . 'transfer order template' }.
		{ #senderName . #val: . ''}.
		{ #transferAmount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
	} full: { 
		{ #source .  #val: . '' }.
		{ #target .  #val: . '' }.
		{ #date .  #date: . ''}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:24'!
transfers 
	^GbtBigListAC struct: 'Transfers' define: {
		{#displayAs: . 'Transfers'} .
		{#noPolicyPrefix: . 'MTF'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #wallet} .
		{#templates: . self transferOrder} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(senderName von) #(transferAmount amount) currency #(source von) #(target an))} .
		{#subcontext: . self transferContext}.
	}! !
